Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.distribution
Class HypergeometricDistribution

    java.lang.Object
      org.apache.commons.math3.distribution.AbstractIntegerDistribution
          org.apache.commons.math3.distribution.HypergeometricDistribution

All Implemented Interfaces:
  Serializable, IntegerDistribution

    public class HypergeometricDistribution

extends AbstractIntegerDistribution

Implementation of the hypergeometric distribution.

Version:
  $Id: HypergeometricDistribution.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Hypergeometric distribution (Wikipedia), Hypergeometric distribution (MathWorld), Serialized Form

Field Summary

Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution
`random, randomData`

Constructor Summary
`HypergeometricDistribution(int populationSize, int numberOfSuccesses, int sampleSize)` Construct a new hypergeometric distribution with the specified population size, number of successes in the population, and sample size.
`HypergeometricDistribution(RandomGenerator rng, int populationSize, int numberOfSuccesses, int sampleSize)` Creates a new hypergeometric distribution.

Method Summary
`protected double` | `calculateNumericalVariance()` Used by `getNumericalVariance()`.
`double` | `cumulativeProbability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`int` | `getNumberOfSuccesses()` Access the number of successes.
`double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`int` | `getPopulationSize()` Access the population size.
`int` | `getSampleSize()` Access the sample size.
`int` | `getSupportLowerBound()` Access the lower bound of the support.
`int` | `getSupportUpperBound()` Access the upper bound of the support.
`boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`double` | `probability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.
`double` | `upperCumulativeProbability(int x)` For this distribution, `X`, this method returns `P(X >= x)`.

Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution
`cumulativeProbability, inverseCumulativeProbability, reseedRandomGenerator, sample, sample, solveInverseCumulativeProbability`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### HypergeometricDistribution

    public HypergeometricDistribution(int populationSize,
                                      int numberOfSuccesses,
                                      int sampleSize)
                               throws NotPositiveException,
                                      NotStrictlyPositiveException,
                                      NumberIsTooLargeException

  Construct a new hypergeometric distribution with the specified population size, number of successes in the population, and sample size.

  Parameters:
    `populationSize` - Population size.
    `numberOfSuccesses` - Number of successes in the population.
    `sampleSize` - Sample size.
  Throws:
    `NotPositiveException` - if `numberOfSuccesses < 0`.
    `NotStrictlyPositiveException` - if `populationSize <= 0`.
    `NumberIsTooLargeException` - if `numberOfSuccesses > populationSize`, or `sampleSize > populationSize`.

### HypergeometricDistribution

    public HypergeometricDistribution(RandomGenerator rng,
                                      int populationSize,
                                      int numberOfSuccesses,
                                      int sampleSize)
                               throws NotPositiveException,
                                      NotStrictlyPositiveException,
                                      NumberIsTooLargeException

  Creates a new hypergeometric distribution.

  Parameters:
    `rng` - Random number generator.
    `populationSize` - Population size.
    `numberOfSuccesses` - Number of successes in the population.
    `sampleSize` - Sample size.
  Throws:
    `NotPositiveException` - if `numberOfSuccesses < 0`.
    `NotStrictlyPositiveException` - if `populationSize <= 0`.
    `NumberIsTooLargeException` - if `numberOfSuccesses > populationSize`, or `sampleSize > populationSize`.
  Since:
    3.1

Method Detail

### cumulativeProbability

    public double cumulativeProbability(int x)

  For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

  Parameters:
    `x` - the point at which the CDF is evaluated
  Returns:
    the probability that a random variable with this distribution takes a value less than or equal to `x`

### getNumberOfSuccesses

    public int getNumberOfSuccesses()

  Access the number of successes.

  Returns:
    the number of successes.

### getPopulationSize

    public int getPopulationSize()

  Access the population size.

  Returns:
    the population size.

### getSampleSize

    public int getSampleSize()

  Access the sample size.

  Returns:
    the sample size.

### probability

    public double probability(int x)

  For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.

  Parameters:
    `x` - the point at which the PMF is evaluated
  Returns:
    the value of the probability mass function at `x`

### upperCumulativeProbability

    public double upperCumulativeProbability(int x)

  For this distribution, `X`, this method returns `P(X >= x)`.

  Parameters:
    `x` - Value at which the CDF is evaluated.
  Returns:
    the upper tail CDF for this distribution.
  Since:
    1.1

### getNumericalMean

    public double getNumericalMean()

  Use this method to get the numerical value of the mean of this distribution. For population size `N`, number of successes `m`, and sample size `n`, the mean is `n * m / N`.

  Returns:
    the mean or `Double.NaN` if it is not defined

### getNumericalVariance

    public double getNumericalVariance()

  Use this method to get the numerical value of the variance of this distribution. For population size `N`, number of successes `m`, and sample size `n`, the variance is `[n * m * (N - n) * (N - m)] / [N^2 * (N - 1)]`.

  Returns:
    the variance (possibly `Double.POSITIVE_INFINITY` or `Double.NaN` if it is not defined)

### calculateNumericalVariance

    protected double calculateNumericalVariance()

  Used by `getNumericalVariance()`.

  Returns:
    the variance of this distribution

### getSupportLowerBound

    public int getSupportLowerBound()

  Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

  `inf {x in Z | P(X <= x) > 0}`.

  For population size `N`, number of successes `m`, and sample size `n`, the lower bound of the support is `max(0, n + m - N)`.

  Returns:
    lower bound of the support

### getSupportUpperBound

    public int getSupportUpperBound()

  Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

  `inf {x in R | P(X <= x) = 1}`.

  For number of successes `m` and sample size `n`, the upper bound of the support is `min(m, n)`.

  Returns:
    upper bound of the support

### isSupportConnected

    public boolean isSupportConnected()

  Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

  Returns:
    `true`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.